/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* Ce logiciel est du domaine public. Vous avez la permission   *
* d'utiliser, de copier et de modifier ce logiciel.            *
****************************************************************
* Ne me contactez pas SVP pour des informations, bugs,         *
* commentaires, problemes, contributions, offres d'emploi.     *
* Si vous aimez ce logiciel, envoyez une carte postale a       *
* l'adresse suivante :                                         *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA (Moldavie)                                           *
****************************************************************
* L'auteur n'est pas responsable pour les dommages occasionnes *
* par l'utilisation de ce logiciel ou de ses derives.          *
\**************************************************************/

import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.*;
import java.util.*;

public class VasLireMail extends Applet {
  Socket sock;
  DataOutputStream out;
  DataInputStream in;
  int nb_mess;//le nombre de messages recus
  Label lEtat, lLogin, lPasswd, lNMess;
  TextArea taContenu;
  TextField tLogin, tPasswd, tNMess;//login-password
  Button bCnx, bLire;
  //pour passer d'une case a l'autre avec tabulation
  public Component[] compo;

  public String getAppletInfo() {
    return (new String("VasLireMail v1.4, 15 decembre 1998, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }

  //constructeur
  public VasLireMail() {
    setLayout(null);
    setBackground(Color.lightGray);
    lEtat=new Label("Entrez le login/mot_de_passe et faites Connexion !");
    lEtat.reshape(10, 10, 350, 25);
    add(lEtat);
    lLogin=new Label("Login :");
    lLogin.reshape(10, 40, 60, 25);
    add(lLogin);
    tLogin=new TextField("vasile");
    tLogin.reshape(70, 40, 100, 25);
    add(tLogin);
    lPasswd=new Label("Password :");
    lPasswd.reshape(170, 40, 75, 25);
    add(lPasswd);
    tPasswd=new TextField();
    tPasswd.setEchoCharacter('*');
    tPasswd.reshape(250, 40, 100, 25);
    add(tPasswd);
    bCnx=new Button("Connexion");
    bCnx.reshape(380, 40, 70, 30);
    add(bCnx);
    lNMess=new Label("Messages a lire :");
    lNMess.reshape(10, 80, 110, 25);
    add(lNMess);
    tNMess=new TextField();
    tNMess.reshape(130, 80, 130, 25);
    add(tNMess);
    bLire=new Button("Lire !");
    bLire.reshape(380, 80, 70, 30);
    add(bLire);
    bLire.disable();
    taContenu=new TextArea();
    taContenu.reshape(20, 120, 430, 150);
    taContenu.setEditable(false);
    add(taContenu);
    taContenu.appendText("C'est un utilitaire de lecture d'e-mail pour les abonnes");
    taContenu.appendText("\nde chez.com. Saisissez votre login SANS @chez.com.");
    taContenu.appendText("\nPour lire vos messages, tapez les numeros des messages");
    taContenu.appendText("\nsepares par des espaces.");
    taContenu.appendText("\nPour lire TOUS les messages, laissez vide");
    taContenu.appendText("\n(C) 1997, 1998, 1999, 2000 Vasile Calmatui, vasile@wook.com");
    resize(470, 290);
  }//fin constructeur

  public void init() {
    //pour passer d'une case a l'autre avec tabulation
    compo=new Component[5];
    compo[0]=tLogin;
    compo[1]=tPasswd;
    compo[2]=bCnx;
    compo[3]=tNMess;
    compo[4]=taContenu;
    compo[0].requestFocus();
    if(compo[0] instanceof TextComponent) ((TextComponent)compo[0]).selectAll();
  }//fin init

  public void goCnx() {
    try {
      lEtat.setText("Connexion en cours..");
      sock=new Socket(getCodeBase().getHost(), 110);
      out=new DataOutputStream(sock.getOutputStream());
      in=new DataInputStream(sock.getInputStream());

      //+OK QPOP (version 2.2) at galaxy.cheze.com starting.
      lEtat.setText("Connecte a "+getCodeBase().getHost());
      in.readLine();
      out.writeBytes("user "+tLogin.getText()+"\r\n");
      lEtat.setText("user "+tLogin.getText());

      //+OK Password required for vasile.
      in.readLine();
      out.writeBytes("pass "+tPasswd.getText()+"\r\n");
      lEtat.setText("pass ********");

      //+OK vasile has 1 message (55210 octets).
      in.readLine();
      out.writeBytes("stat\r\n");
      String ligne=in.readLine();

      if(ligne.charAt(0)=='+') {
        //tout ok
        lEtat.setText("Cnx OK");
        //on lit combien des messages il y a sur le serveur
        //+OK vasile has 1 message (1266 octets).
        nb_mess=Integer.parseInt(ligne.substring(4, ligne.indexOf(' ', 5)));
        //taille totale des messages
        int taille_tot=Integer.parseInt(ligne.substring(ligne.indexOf(' ', 5)+1));
        lEtat.setText(":-) Vous avez "+nb_mess+" messages de "+taille_tot+" octets");
      }
      //si une erreur quelque part
      else {lEtat.setText("Probleme login/password !"); bCnx.enable(); return;}

      out.writeBytes("list\r\n");

      //+OK 1 messages (1266 octets)
      ligne=in.readLine();

      //pour lire la taille des messages
      for(int i=0; i<nb_mess; i++) {
        //1 1266
        ligne=in.readLine();
        if(ligne==".") {return;}
        //la longueur du message en cours
        int long_mess=Integer.parseInt(ligne.substring(ligne.indexOf(' ')+1));
        taContenu.appendText("\nMESSAGE "+(i+1)+" TAILLE "+long_mess);
      }

      //.
      ligne=in.readLine();
      bLire.enable();
    }
    catch(IOException e) {lEtat.setText("Impossible de se connecter ou Cnx fermee");}
  };//fin goCnx()

  public boolean handleEvent(Event e) {
    //pour passer d'une case a l'autre avec tabulation
    if(e.id==Event.KEY_PRESS && e.key == '\t') {
      for(int i=0; i<compo.length; i++) {
        if(e.target==compo[i]) {
          //en IE4, le texte reste selectionne
          //c'est pas joly, donc on de-selectionne avant de partir
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).select(0, 0);
          //s'il y a un composant "disabled", on passe plus loin
          do {
            i=(i+(e.shiftDown() ? compo.length-1 : 1))%compo.length;
          } while(!compo[i].isEnabled());
          compo[i].requestFocus();
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).selectAll();
          return true;
        }
      }
      return false;
    }//fin '\t'

    //si on appuie sur Connexion !, on se connecte
    if(e.target==bCnx && (e.arg==bCnx.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      if(tPasswd.getText().length()==0 || tLogin.getText().length()==0) {
        lEtat.setText("Veuillez ecrire votre login/mot_de_passe !");
        return true;
      }
      bCnx.disable();//on ne peut pas envoyer 2 fois DE SUITE
      //si Envoyer appuye, on initialise le socket
      //et on envoie la requete au central
      goCnx();
      return true;
    }

    //si on apuie sur Lire, on lit les messages
    if(e.target==bLire && (e.arg==bLire.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      bLire.disable();
      try{
        String Lu=new String(tNMess.getText().trim());
        if(Lu.length()==0) {
          taContenu.appendText("\nOn lit tous les messages = "+nb_mess);
          for(int l=0; l<nb_mess; l++) lireMsg(l+1);
        }
        //s'il a entre des numero de messages particuliers
        else {
          StringTokenizer st=new StringTokenizer(Lu.toString());
          while(st.hasMoreTokens()) {
            lireMsg(Integer.parseInt(st.nextToken()));
          }
        }
      }
      catch(Exception ee) {lEtat.setText("Quel Numero ?? Inexistant !");}

      try {
        //on ferme tout
        out.writeBytes("QUIT\r\n");
        lEtat.setText("Connexion fermee");
        sock.close();
      }
      catch(IOException eee){;}
      bCnx.enable();
      return true;
    }//fin si on appuie sur Lire !
    return false;//les autres evenements ne seront pas traites
  }//fin handleEvent

  //fonction de lecture d'n message
  void lireMsg(int num_mess) {
    taContenu.appendText("\n*******************************");
    taContenu.appendText("\nMessage numero : "+num_mess);
    if(num_mess<1 || num_mess>nb_mess) {
      lEtat.setText("Numero "+num_mess+" incorrect !");
      taContenu.appendText("\nNumero incorrect !");
      return;
    }

    try {
      out.writeBytes("retr "+num_mess+"\r\n");
      lEtat.setText("On lit le message "+num_mess);
      //+OK 963 octets
      in.readLine();
      //premiere ligne du message
      String ligne=in.readLine();
      while(!ligne.equals(".")) {
        taContenu.appendText("\n"+ligne);
        ligne=in.readLine();
      }
      lEtat.setText("Message "+num_mess+" bien recu");
    }
    catch(IOException exc) {lEtat.setText("Probleme lecture message "+num_mess); return;}
  }//fin lireMsg
}//fin classe VasLireMail
